# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from twisted.internet import reactor, defer

from pySndo.game.weapon import Glock, SIGP, DesertEagle, \
    Benelli, MP5, Galil, SVD, AK47, Colt, G3A3, SR60, AW50, GasGrenade, \
    HEGrenade, C4, Flashbang, MolotovCocktail, SmokeGrenade, Medipack

class _Crate(object):
    x = None
    y = None
    expireTime = 10 # fill in please
    possibleContent = None
    
    removedDefer = None
    
    def __init__(self, crateList):
        self.possibleContent = self.possibleContent[:]
        self.removedDefer = defer.Deferred()
        reactor.callLater(self.expireTime, self._removeCrate, crateList)

    def removeCrate(self):
        return self.removedDefer
        
    def _removeCrate(self, crateList):
        crateList.remove(self)
        self.removedDefer.callback(self)

guns = [
    Glock, 
    SIGP, 
    DesertEagle, 
    Benelli,
    MP5, 
    Galil, 
    SVD, 
    AK47, 
    Colt, 
    G3A3, 
    SR60, 
    AW50
]

grenades = [
    GasGrenade,
    HEGrenade,
    SmokeGrenade,
    MolotovCocktail,
    Flashbang
]

class GunCrate(_Crate):
    possibleContent = guns
    
class GrenadeCrate(_Crate):
    possibleContent = grenades

class HealthCrate(_Crate):
    possibleContent = [Medipack]