# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

class _Team(object):
    """
    Base team class.
    
    @ivar score: Score of this team.
    """
    _factory = None
    score = 0
    
    def __init__(self, factory):
        self._factory = factory
        
    def getName(self):
        return self._team
    
    def getAliveConnections(self):
        return [connection for connection in self.getConnections()
                if connection.player.alive]
        
    def getConnections(self):
        """
        Get the connections of this team.
        """
        team = self._team
        return [connection for connection
                in self._factory.connections
                if connection.player.getTeam() == team]

class Terrorist(_Team):
    """
    Class that represents the terrorist team.
    """

    _team = 'Terrorist'
    
class Police(_Team):
    """
    Class that represents the terrorist team.
    """

    _team = 'Police'