# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

class _Weapon(object):
    """
    Weapon base
    """
    damage = None
    name = None
    rounds = None
    fireRate = None
    reloadTime = None
    recoil = None
    range = None
    price = None
    ammoPrice = None
    heal = None # for medipack

class Glock(_Weapon):
    name = 'Glock 19C'
    damage = (6, 16)
    rounds = 15
    fireRate = 420
    reloadTime = 3400
    recoil = 15
    range = 480

class SIGP(_Weapon):
    name = 'SIGP 228'
    damage = (9, 18)
    rounds = 13
    fireRate = 500
    reloadTime = 3600
    recoil = 16
    range = 400
    
class DesertEagle(_Weapon):
    name = 'Desert Eagle'
    damage = (18, 27)
    rounds = 7
    fireRate = 480
    reloadTime = 3000
    recoil = 20
    range = 420
    price = 1200
    ammoPrice = 40

class _Benelli(_Weapon):
    name = 'Benelli M1'
    damage = (14, 67)
    rounds = 8
    fireRate = 800
    reloadTime = 4000
    recoil = 30
    range = 400
    price = 1300
    ammoPrice = 60

class Benelli(_Benelli):
    pass

class BenelliHit(_Benelli):
    pass

class MP5(_Weapon):
    name = 'MP-5'
    damage = (8, 18)
    rounds = 30
    fireRate = 300
    reloadTime = 4000
    recoil = 14
    range = 450
    price = 1500
    ammoPrice = 50

class Galil(_Weapon):
    name = 'Galil'
    damage = (14, 23)
    rounds = 25
    fireRate = 240
    reloadTime = 4000
    recoil = 17
    range = 450
    price = 2000
    ammoPrice = 50

class SVD(_Weapon):
    name = 'SVD'
    damage = (11, 27)
    rounds = 10
    fireRate = 320
    reloadTime = 4000
    recoil = 20
    range = 800
    price = 2300
    ammoPrice = 80
    
class AK47(_Weapon):
    name = 'AK-47'
    damage = (10, 21)
    rounds = 30
    fireRate = 240
    reloadTime = 4000
    recoil = 14
    range = 500
    price = 2000
    ammoPrice = 75
    
class Colt(_Weapon):
    name = 'Colt M4A1'
    damage = (17, 28)
    rounds = 30
    fireRate = 280
    reloadTime = 4000
    recoil = 22
    range = 500
    price = 2500
    ammoPrice = 75

class G3A3(_Weapon):
    name = 'G3A3'
    damage = (22, 33)
    rounds = 20
    fireRate = 440
    reloadTime = 4000
    recoil = 27
    range = 500
    price = 2800
    ammoPrice = 100

class SR60(_Weapon):
    name = 'SR-60'
    damage = (35, 51)
    rounds = 4
    fireRate = 1000
    reloadTime = 4000
    recoil = 50
    range = 800
    price = 3000
    ammoPrice = 75

class AW50(_Weapon):
    name = 'AW-50 Sniper'
    damage = (52, 120)
    rounds = 1
    fireRate = 4000
    reloadTime = 3200
    recoil = 50
    range = 800
    price = 3800
    ammoPrice = 30

class GasGrenade(_Weapon):
    name = 'Gas Grenade'
    damage = (25, 28)
    price = 200

class HEGrenade(_Weapon):
    name = 'HE Grenade'
    damage = (50, 55)
    price = 350

class C4(_Weapon):
    name = 'C4'
    damage = (50, 110)
    price = 400

class Flashbang(_Weapon):
    name = 'Flashbang'
    price = 350

class MolotovCocktail(_Weapon):
    name = 'Molotov Cocktail'
    price = 700

class SmokeGrenade(_Weapon):
    name = 'Smoke Grenade'
    price = 300
    
class Medipack(_Weapon):
    name = 'Medipack'
    heal = 40

class Other(_Weapon):
    name = 'Other'

weaponList = [
    Glock, 
    SIGP, 
    DesertEagle, 
    Benelli,
    BenelliHit,
    MP5, 
    Galil, 
    SVD, 
    AK47, 
    Colt, 
    G3A3, 
    SR60, 
    AW50, 
    GasGrenade, 
    HEGrenade, 
    C4, 
    Flashbang, 
    MolotovCocktail, 
    SmokeGrenade, 
    Medipack
]

weaponDict = {}

for weapon in weaponList:
    weaponDict[weapon.name] = weapon