# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

import os

def checkDefault(value, *defaults):
    if not value in defaults:
        raise NotImplementedError('%s is not matching defaults %s!' %
        (value, defaults))
    return value
        
def shift_encrypt(data, shift):
    encrypted = ''
    for character in list(data):
        encrypted += chr((ord(character)+shift) % 256)
    return encrypted
    
def shift_decrypt(data, shift):
    encrypted = ''
    for character in list(data):
        encrypted += chr((ord(character)-shift) % 256)
    return encrypted
    
def find_key(dict, value):
    for key, dictValue in dict.iteritems():
        if dictValue == value:
            return key
    raise ValueError('value not found!')
    
def create_number(number, decimals):
    return ('%%0%sd' % decimals) % number

# map things
    
MAP_ENCRYPT_SHIFT = 8

mapBackgroundTypes = [
'None', 'Grass', 'Desert', 'Dust', 'Dark Grass', 'Water']

mapGameTypes = [
'None', 'Deathmatch', 'Last Team Standing', 'Team Deathmatch']

MAP_OBJECT_SPAWN = 0
MAP_OBJECT_TILE = 1
MAP_OBJECT_BACKGROUND = 2

mapObjects = {
   -3 : ('Terrorist Spawn Point', MAP_OBJECT_SPAWN),
   -2 : ('Police Spawn Point', MAP_OBJECT_SPAWN),
   -1 : ('Deathmatch Spawn Point', MAP_OBJECT_SPAWN),
    1 : 'Tree',
    2 : 'Rock',
    3 : ('Ground', MAP_OBJECT_BACKGROUND),
    4 : 'Stone',
    5 : 'Dead Tree',
    6 : 'House', 
    7 : ('Sidewalk Horizontal', MAP_OBJECT_BACKGROUND),
    8 : ('Broken Sidewalk Horizontal', MAP_OBJECT_BACKGROUND),
    9 : ('Street Horizontal', MAP_OBJECT_BACKGROUND),
   10 : 'Police Car',
   11 : 'Police Car 2',
   12 : 'Stone 2',
   13 : 'Tree 2',
   14 : ('Street Vertical', MAP_OBJECT_BACKGROUND),
   15 : ('Sidewalk Vertical', MAP_OBJECT_BACKGROUND),
   16 : ('Crossroad', MAP_OBJECT_BACKGROUND),
   17 : 'Rock 2',
   18 : 'Rock 3',
   19 : 'Rock 4',
   20 : ('Skeleton', MAP_OBJECT_BACKGROUND),
   21 : 'Bush',
   22 : 'Box',
   23 : ('Destroyed Box', MAP_OBJECT_BACKGROUND),
   24 : 'Gate',
   25 : 'Bush 2',
   26 : ('Boulders', MAP_OBJECT_BACKGROUND),
   27 : 'Cactus',
   28 : 'Small Cactus',
   29 : 'Stone 3',
   30 : 'Tombstone',
   31 : ('Floor', MAP_OBJECT_BACKGROUND),
   32 : ('Floor 2', MAP_OBJECT_BACKGROUND),
   33 : ('Wooden Floor', MAP_OBJECT_BACKGROUND),
   34 : ('Stone Floor', MAP_OBJECT_BACKGROUND),
   35 : 'Wall Vertical',
   36 : 'Wall Horizontal',
   37 : 'Wall 2 Vertical',
   38 : 'Wall 2 Horizontal',
   39 : 'Tree 3',
   40 : 'Pond',
   41 : 'Rubble',
   42 : ('Skeleton 2', MAP_OBJECT_BACKGROUND),
   43 : 'Entrance',
   44 : 'Lantern',
   45 : 'Burning Box',
   46 : 'Hill',
   47 : 'Pipeline',
   48 : 'Fence Horizontal',
   49 : 'Fence Vertical',
   50 : ('Broken Pipeline', MAP_OBJECT_BACKGROUND),
   51 : ('Grass', MAP_OBJECT_BACKGROUND),
   52 : ('Desert', MAP_OBJECT_BACKGROUND),
   53 : ('Dust', MAP_OBJECT_BACKGROUND),
   54 : 'Wall Diagonal 1',
   55 : 'Wall Diagonal 2',
   56 : 'Wall 2 Diagonal 1',
   57 : 'Wall 2 Diagonal 2'
}

def getObjectTypeByName(name):
    for key, value in mapObjects.iteritems():
        if type(value) == tuple:
            value = value[0]
        if value == name:
            return key
    return False
    
def getObjectNameByType(objectType):
    for key, value in mapObjects.iteritems():
        if type(value) == tuple:
            value = value[0]
        if value == objectType:
            return key
    return False

# network

INFO_KEY = '\xF8\x38\xFA\x32\x4A\xDB\xAE\x91\x3D\xD5\
\x2E\x99\xB3\x5F\x79\x7F\x2F\x55\x25\x30\x43\xD9'

GET_INITIAL = '000'
GET_MAP_SENDING = '001'
SEND_MAP = '002'

playerTeam = ['Generic', 'Police', 'Terrorist']

# game settings

PLAYER_SPEED = 56 # 56 pixels per second