# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from pySndo.locals import *

class Object(object):
    x = None
    y = None
    type = None
    def __init__(self, dataLine):
        splitted = dataLine.split(',')
        self.type = int(splitted.pop(0))
        self.x = int(splitted.pop(0))
        self.y = int(splitted.pop(0))
        self.load()

    def load(self):
        """
        Used by subclasses to load unique properties.
        """
        
    def getObjectType(self):
        value = mapObjects[self.type]
        if type(value) == tuple:
            value = value[0]
        return value
        
    def setObjectType(self, objectType):
        for index, value in mapObjects.iteritems():
            if type(value) == tuple:
                value = [0]
            if value == objectType:
                self.type = index
                return True
        return False
        
    def isBackground(self):
        value = mapObjects[self.type]
        if type(value) == tuple:
            value = value[1]
        return value == MAP_OBJECT_BACKGROUND
        
    def generate(self):
        return ','.join([str(item) for item in [self.type, self.x, self.y]])

class Spawn(Object):
    """
    Player spawn object.
    """
    def load(self):
        pass
        
