# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from pySndo.network.packetloaders.common import PrefixSend, StringSend, Empty

from pySndo.locals import find_key, checkDefault

from pySndo.game.crate import GunCrate, GrenadeCrate, HealthCrate

crateTypes = {
    None : GunCrate,
    4 : HealthCrate,
    8 : GrenadeCrate,
    24 : GunCrate,
    28 : GunCrate
}

class CurrentMap(StringSend):
    pass

class SetMap(PrefixSend):
    mapName = None
    mapCrc = None
    
    def _load(self, data):
        #dm_assault,1923475692
        self.mapName, self.mapCrc = data.split(',')
        
    def _generate(self):
        return ','.join([self.mapName, str(self.mapCrc)])
        
class PlayerScore(PrefixSend):
    score = None
    def _load(self, data):
        self.score = int(data)
        
    def _generate(self):
        return str(self.score)

class MapStart(object):
    def __init__(self, data = None):
        if data:
            if int(data) != 0:
                raise NotImplementedError('mapstart is not null')
                
    def generate(self):
        return '0'

class SpawnItem(PrefixSend):
    crateType = None
    x = None
    y = None

    def _load(self, data):
        if len(data) > 8:
            self.crateType = int(data[:-8])
            data = data[-8:]
        self.y = int(data[:3])
        self.x = int(data[3:6])
    
    def setCrateType(self, crateType):
        self.crateType = find_key(crateTypes, crateType)
        
    def getCrateType(self):
        return crateTypes[self.crateType]
    
    def _generate(self):
        crateType = ''
        if self.crateType:
            crateType = create_number(self.crateType, 2)

        return (crateType + create_number(self.y, 3) + 
                create_number(self.x, 3), create_number(0, 2))

class GotMedipack(PrefixSend):
    def _load(self, data):
        checkDefault(int(data), 0)
        
    def _generate(self):
        return '0'

class BombedArea(PrefixSend):
    x = None
    y = None
    
    def _load(self, data):
        self.x, self.y = [int(item) for item in data.split(',')]
        
    def generate(self):
        return ','.join([str(item) for item in [self.x, self.y]])