# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from twisted.internet import reactor

from twisted.internet.task import LoopingCall

from pySndo.network.site.transmitters import AddServer, DeleteServer
from pySndo.network.site.parsers import Server

class ServerUpdater(object):
    name = None
    port = None
    infoFactory = None
    updateLoop = None

    def __init__(self, name, infoFactory, port, interval = 250):
        self.name = name
        self.infoFactory = infoFactory
        self.port = port
        updateLoop = LoopingCall(self.update)
        self.updateLoop = updateLoop
        updateLoop.start(interval)

        reactor.addSystemEventTrigger('before', 'shutdown', self.shutdownCalled)
        
    def update(self):
        gameFactory = self.infoFactory.gameFactory
        map = gameFactory.map
        newServer = Server()
        newServer.name = self.name
        newServer.gameType = map.data.getGameType()
        newServer.map = map.name
        newServer.currentPlayers = len(gameFactory.connections)
        newServer.maxPlayers = gameFactory.maxPlayers
        newServer.port = self.port
        newServer.passworded = bool(self.infoFactory.password)
        d = AddServer(newServer).getParser()
        d.addErrback(self.error)
        return d
            
    def close(self):
        d = DeleteServer().getParser()
        d.addErrback(self.error)
        return d

    def error(self, reason):
        print 'Error:', reason
    
    def shutdownCalled(self):
        return self.close()