# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

try:
    import psyco
    psyco.full()
except ImportError:
    print '(no psyco)'
    
import traceback

from twisted.internet import reactor

from pySndo.network.server import ServerGameProtocol, ServerGameFactory, \
    ServerInfoProtocol, ServerInfoFactory

from pySndo.network.site.updater import ServerUpdater

from pySndo.map.loader import loadMap

import random

welcome = [
    'This is an example server',
    'Have fun, enjoy, something!',
    '',
    '',
    '*dance*'
]

class MyGameProtocol(ServerGameProtocol):
    def loggedIn(self, name):
        print 'logged in, sending message'
        self.sendMessages(welcome, 5, 0, 1.5)
            
    def kick(self, *arg, **kw):
        ServerGameProtocol.kick(self, *arg, **kw)
        print 'Kicked %s' % self.name

class MyGameFactory(ServerGameFactory):
    protocol = MyGameProtocol
    
    def startFactory(self):
        ServerGameFactory.startFactory(self)
        self.banned = []

    maxPlayers = 50
    maxPing = 4000
    map = loadMap('lts_speedball', './../../Maps/')

class MyInfoProtocol(ServerInfoProtocol):
    def initialSent(self):
        print '(initial sent)'
        
    def mapTransferStarted(self, map):
        print '(map transfer started)'

    def mapProgress(self, map, currentLines, totalLines):
        pass
    
    def mapSent(self, map):
        print '(map transferred successfully!)'
    
    def mapTransferringSent(self):
        print '(sent mapsending)'

class MyInfoFactory(ServerInfoFactory):
    protocol = MyInfoProtocol

    welcome = None

def main():
    serverName = 'Test server %s' % random.randrange(0, 1000)
    basePort = 1203
    gameFactory = MyGameFactory()
    infoFactory = MyInfoFactory(gameFactory)
    infoPort = reactor.listenTCP(basePort+1, infoFactory)
    gamePort = reactor.listenTCP(basePort, gameFactory)
    newUpdater = ServerUpdater(serverName, infoFactory, basePort)
    print 'Listening on port %s and %s...' % (infoPort.port, gamePort.port)
    reactor.run()
    
if __name__ == '__main__':
    main()